

import cAdjoint

import sys

def processStates(ghostNum,valueNum):


    states = cAdjoint.generateStates(ghostNum,valueNum)


    counter = 0

    for item in states:
        if not item.stateIsLegal(valueNum):
            continue

        counter+=1


        image = cAdjoint.Q(item)

        resultKey = []
        result = []
        

        for element in image:
            secondImage = cAdjoint.Q(element[1])
            for element2 in secondImage:
                if element2[1] not in resultKey:
                    resultKey.append(element2[1])
                    #multiply by 2 to avoid fractions
                    result.append(2*element[0]*element2[0])

                else:
                    #multiply by 2 to avoid fractions
                    result[resultKey.index(element2[1])]+=2*element[0]*element2[0]


        for index in range(0,len(resultKey)):
            if result[index]!=0:
                print item,"gives squiffy result"
                for cramp in image:
                    print cramp[0],cramp[1],cAdjoint.Q(cramp[1])
                print ""
                print result[index],resultKey[index]
                print ""

    print "total is",counter



if __name__ == "__main__":


    if len(sys.argv)!=3:
        print "error: require a label for the atypical, a ghost number argument and a second index value"
        sys.exit(0)

    ghostNum = int(sys.argv[1])
    valueNum = int(sys.argv[2])

    print "ghost number is",ghostNum
    print "second index value is",valueNum

    processStates(ghostNum,valueNum)
