
import sys,numpy


class letter(object):
    def __init__(self,name):
        self.name = name


    def __repr__(self):
        return self.name

class algebra(letter):
    pass


class ghost(letter):
    pass








S11p = algebra("S11p")
S11p.j = 1
S11p.i = 1
S11p.f = 1

S11m = algebra("S11m")
S11m.j = -1
S11m.i = -1
S11m.f = 1

S12p = algebra("S12p")
S12p.j = 1
S12p.i = 1
S12p.f = 1

S12m = algebra("S12m")
S12m.j = -1
S12m.i = -1
S12m.f = 1


S21p = algebra("S21p")
S21p.j = 1
S21p.i = -1
S21p.f = 1

S21m = algebra("S21m")
S21m.j = -1
S21m.i = 1
S21m.f = 1

S22p = algebra("S22p")
S22p.j = 1
S22p.i = -1
S22p.f = 1

S22m = algebra("S22m")
S22m.j = -1
S22m.i = 1
S22m.f = 1




Jp = algebra("Jp")
Jp.j = 2
Jp.i = 0
Jp.f = 0

J3 = algebra("J3")
J3.j = 0
J3.i = 0
J3.f = 0

Jm = algebra("Jm")
Jm.j = -2
Jm.i = 0
Jm.f = 0



Jtp = algebra("Jtp")
Jtp.j = 0
Jtp.i = 2
Jtp.f = 0

Jt3 = algebra("Jt3")
Jt3.j = 0
Jt3.i = 0
Jt3.f = 0

Jtm = algebra("Jtm")
Jtm.j = 0
Jtm.i = -2
Jtm.f = 0



bp = ghost("bp")
bp.j = 2
bp.i = 0
bp.f = 1

b3 = ghost("b3")
b3.j = 0
b3.i = 0
b3.f = 1

bm = ghost("bm")
bm.j = -2
bm.i = 0
bm.f = 1



btp = ghost("btp")
btp.j = 0
btp.i = 2
btp.f = 1

bt3 = ghost("bt3")
bt3.j = 0
bt3.i = 0
bt3.f = 1

btm = ghost("btm")
btm.j = 0
btm.i = -2
btm.f = 1


b11p = ghost("b11p")
b11p.j = 1
b11p.i = 1
b11p.f = 0

b11m = ghost("b11m")
b11m.j = -1
b11m.i = -1
b11m.f = 0

b12p = ghost("b12p")
b12p.j = 1
b12p.i = 1
b12p.f = 0

b12m = ghost("b12m")
b12m.j = -1
b12m.i = -1
b12m.f = 0


b21p = ghost("b21p")
b21p.j = 1
b21p.i = -1
b21p.f = 0

b21m = ghost("b21m")
b21m.j = -1
b21m.i = 1
b21m.f = 0

b22p = ghost("b22p")
b22p.j = 1
b22p.i = -1
b22p.f = 0

b22m = ghost("b22m")
b22m.j = -1
b22m.i = 1
b22m.f = 0



ghosts = [bp,b3,bm,btp,bt3,btm,b11p,b11m,b12p,b12m,b21p,b21m,b22p,b22m]

algebras = [S11p,S11m,S12p,S12m,S21p,S21m,S22p,S22m,Jp,J3,Jm,Jtp,Jt3,Jtm]


ones = [b11m,b11p,b21m,b21p,S11m,S11p,S21m,S21p]
twos = [b12m,b12p,b22m,b22p,S12m,S12p,S22m,S22p]


#defined sorting order
counter = 1
for letter in algebras + ghosts:
    letter.order = counter
    counter+=1



def isodd(number):
    return number - 2*(number/2)



class operator(list):


    def sortNice(self):
        self.sort(key=lambda goat: goat.order)

    def totals(self):
        self.jtotal = 0
        self.itotal = 0
        self.value = 0


        for item in self:
            self.jtotal+=item.j
            self.itotal+=item.i
            if item in ones:
                self.value+=1
            elif item in twos:
                self.value-=1




    def countFermions(self):
        result = 0
        for item in self:
            result+=item.f

        return result



    def isVeryLegal(self,valueNum):
        
        self.totals()
        
        # this is for Jp^n
        if self.itotal==1 and self.jtotal<=-1 and isodd(self.jtotal) and self.value==valueNum:
            pass
        # this is for S11p Jp^n
        elif self.itotal==0 and self.jtotal<=-2 and (1-isodd(self.jtotal)) and self.value==valueNum-1:
            pass
        # this is for S12p Jp^n
        elif self.itotal==0 and self.jtotal<=-2 and (1-isodd(self.jtotal)) and self.value==valueNum+1:
            pass
        # this is for Jtp Jp^n
        elif self.itotal==-1 and self.jtotal<=-1 and isodd(self.jtotal) and self.value==valueNum:
            pass
        else:
            return 0

        for item in ghosts:
            if self.count(item)>1 and item.f==1:
                return 0


        return 1

    def isLegal(self):

        self.totals()

        if self.itotal==-1 and self.jtotal<=-1 and isodd(self.jtotal):
            pass
        elif self.itotal==1 and self.jtotal<=-1 and isodd(self.jtotal):
            pass
        elif self.itotal==0 and self.jtotal<=-2 and (1-isodd(self.jtotal)):
            pass
        else:
            return 0

        for item in ghosts:
            if self.count(item)>1 and item.f==1:
                return 0


        return 1




    def fastLegal(self,valueNum):
        self.jtotal = 0
        self.itotal = 0

        for item in self:
            self.jtotal+=item.j
            self.itotal+=item.i



        if self.jtotal>=0:
            return 0

        if self.itotal>=2:
            return 0

        if self.itotal<=-2:
            return 0


        self.value = 0


        for item in self:
            if item in ones:
                self.value+=1
            elif item in twos:
                self.value-=1

        if self.value>=valueNum+2:
            return 0

        if self.value<=valueNum-2:
            return 0

        # this is for Jp^n
        if self.itotal==1 and isodd(self.jtotal) and self.value==valueNum:
            pass
        # this is for S11p Jp^n
        elif self.itotal==0 and (1-isodd(self.jtotal)) and self.value==valueNum-1:
            pass
        # this is for S12p Jp^n
        elif self.itotal==0 and (1-isodd(self.jtotal)) and self.value==valueNum+1:
            pass
        # this is for Jtp Jp^n
        elif self.itotal==-1 and isodd(self.jtotal) and self.value==valueNum:
            pass
        else:
            return 0

        for item in ghosts:
            if self.count(item)>1 and item.f==1:
                return 0


        return 1






    # pad out ghosts with correct matter
    def addMatter(self,valueNum):
    
        jToDo = -self.jtotal-1
        iToDo = -self.itotal+1

        if iToDo==0:
            if isodd(jToDo):
                print "error!"
            else:
                self.extend([Jp]*(jToDo/2))
        elif iToDo==2:
            if isodd(jToDo):
                print "error!"
            else:
                self.extend([Jtp]+[Jp]*(jToDo/2))
        elif iToDo==1:
            if (1-isodd(jToDo)):
                print "error!"
            else:
                if valueNum-self.value==1:
                    self.extend([S11p]+[Jp]*((jToDo-1)/2))
                elif valueNum-self.value==-1:
                    self.extend([S12p]+[Jp]*((jToDo-1)/2))
                else:
                    print "error, incompatible value!"

        self.sortNice()



    def toPrint(self):
        toString = ""

        for item in self:
            toString+=item.__repr__() + " "

        return toString
     


    def killGhost(self,toKill):
        result=operator(self[:])        
        if toKill.f==1:
            coeff = (-1)**operator(result[:result.index(toKill)]).countFermions()
        else:
            if toKill in ones:
                coeff = -result.count(toKill)
            elif toKill in twos:
                coeff = result.count(toKill)
            else:
                print "error!"

        result.remove(toKill)
        
        return coeff,result


    def addGhost(self,toAdd):
        result = operator(self[:])
        result.append(toAdd)
        result.sortNice()
        if toAdd.f==1:
            sign = (-1)**operator(result[:result.index(toAdd)]).countFermions()
        else:
            sign = 1

        return sign,result


def combinations(length):
    if length == 0:
        yield []
        return
    for x in ghosts:
        for y in combinations(length-1):
            yield [x]+y





#the BRST operator acts
def Q(operand):
    final = []

    #quadratic terms first

    #these are dealt with separately so that matter algebra can be
    #implemented by hand

    # remember to include sign; in general factors form {c^+,b^-} are included

    n = operand.count(Jp)

    if bp in operand:
        coeff,result = operand.killGhost(bp)
        result.insert(0,Jp)
        result.sortNice()
        final.append([coeff,result])


    if b3 in operand:
        coeff,result = operand.killGhost(b3)
        coeff2 = 0.5 + result.count(Jp) + 0.5*result.count(S11p) + 0.5*result.count(S12p)
        final.append([coeff*coeff2,result])


    if bm in operand:
        coeff,result = operand.killGhost(bm)
        if S11p in result:
            if n==0:
                coeff2 = 0
            else:
                coeff2 = -n*(n+1)
                result.remove(Jp)
        elif S12p in result:
            if n==0:
                coeff2 = 0
            else:
                coeff2 = -n*(n+1)
                result.remove(Jp)
        elif Jtp in result:
            if n==0:
                coeff2 = 0
            else:
                coeff2 = -n*n
                result.remove(Jp)
        else:
            if n==0:
                coeff2 = 0
            else:
                coeff2 = -n*n
                result.remove(Jp)

        if coeff2!=0:
            final.append([coeff*coeff2,result])




    if btp in operand and S11p not in operand and S12p not in operand and Jtp not in operand:
        coeff,result = operand.killGhost(btp)
        result.insert(0,Jtp)
        result.sortNice()
        final.append([coeff,result])



    if bt3 in operand:
        coeff,result = operand.killGhost(bt3)
        coeff2 = -0.5 + result.count(Jtp) + 0.5*result.count(S11p) + 0.5*result.count(S12p)
        final.append([coeff*coeff2,result])


    if btm in operand and Jtp in operand:
        coeff,result = operand.killGhost(btm)
        result.remove(Jtp)
        final.append([coeff,result])





    if b11p in operand:
        coeff,result = operand.killGhost(b11p)
        if S11p in result:
            coeff2 = 0
        elif S12p in result:
            coeff2 = -2
            result.remove(S12p)
            result.append(Jtp)
            result.append(Jp)
            result.sortNice()
        elif Jtp in result:
            coeff2 = 0
        else:
            coeff2 = 1
            result.insert(0,S11p)
        
        if coeff2!=0:
            final.append([-1*coeff*coeff2,result])

    if b12p in operand:
        coeff,result = operand.killGhost(b12p)
        if S11p in result:
            coeff2 = 2
            result.remove(S11p)
            result.append(Jtp)
            result.append(Jp)
            result.sortNice()
        elif S12p in result:
            coeff2 = 0
        elif Jtp in result:
            coeff2 = 0
        else:
            coeff2 = 1
            result.insert(0,S12p)

        if coeff2 != 0:
            final.append([coeff*coeff2,result])


    if b21p in operand:
        coeff,result = operand.killGhost(b21p)
        if S11p in result:
            coeff2 = 0
        elif S12p in result:
            coeff2 = 2
            result.remove(S12p)
            result.append(Jp)
            result.sortNice()
        elif Jtp in result:
            coeff2 = 1
            result.remove(Jtp)
            result.insert(0,S11p)
        else:
            coeff2 = 0

        if coeff2 != 0:
            final.append([-1*coeff*coeff2,result])


    if b22p in operand:
        coeff,result = operand.killGhost(b22p)
        if S11p in result:
            coeff2 = -2
            result.remove(S11p)
            result.append(Jp)
            result.sortNice()
        elif S12p in result:
            coeff2 = 0
        elif Jtp in result:
            coeff2 = 1
            result.remove(Jtp)
            result.insert(0,S12p)
        else:
            coeff2 = 0

        if coeff2!=0:
            final.append([coeff*coeff2,result])


    if b11m in operand:
        coeff,result = operand.killGhost(b11m)
        if S11p in result:
            coeff2 = 0
        elif S12p in result:
            coeff2 = -2*(n+1)
            result.remove(S12p)
        elif Jtp in result:
            if n==0:
                coeff2 = 0
            else:
                coeff2 = -n
                result.remove(Jtp)
                result.remove(Jp)
                result.insert(0,S11p)
        else:
            coeff2 = 0
        
        if coeff2!=0:
            final.append([-1*coeff*coeff2,result])


    if b12m in operand:
        coeff,result = operand.killGhost(b12m)
        if S11p in result:
            coeff2 = 2*(n+1)
            result.remove(S11p)
        elif S12p in result:
            coeff2 = 0
        elif Jtp in result:
            if n==0:
                coeff2=0
            else:
                coeff2 = -n
                result.remove(Jtp)
                result.remove(Jp)
                result.insert(0,S12p)
        else:
            coeff2 = 0

        if coeff2!=0:
            final.append([coeff*coeff2,result])


    if b21m in operand:
        coeff,result = operand.killGhost(b21m)
        if S11p in result:
            coeff2 = 0
        elif S12p in result:
            coeff2  = -2*(n+1)
            result.remove(S12p)
            result.append(Jtp)
            result.sortNice()
        elif Jtp in result:
            coeff2 = 0
        else:
            if n==0:
                coeff2 = 0
            else:
                coeff2 = n
                result.remove(Jp)
                result.insert(0,S11p)
        
        if coeff2!=0:
            final.append([-1*coeff*coeff2,result])

    
    if b22m in operand:
        coeff,result = operand.killGhost(b22m)
        if S11p in result:
            coeff2 = 2*(n+1)
            result.remove(S11p)
            result.append(Jtp)
            result.sortNice()
        elif S12p in result:
            coeff2 = 0
        elif Jtp in result:
            coeff2 = 0
        else:
            if n==0:
                coeff2 = 0
            else:
                coeff2 = n
                result.remove(Jp)
                result.insert(0,S12p)

        if coeff2!=0:
            final.append([coeff*coeff2,result])



    # now for the cubic terms


    #term in cubic corresponds to (coefficient term[3])*(b ghost
    #term[2])*(c cong of term[1])*(c cong of term[0])
    #coefficient term[3] includes and 2 from {c^+,b-} = 2

    cubics = [
        [bp,bm,b3,2],
        [b3,bp,bp,1],
        [bm,b3,bm,1],
        [btp,btm,bt3,2],
        [bt3,btp,btp,1],
        [btm,bt3,btm,1],
        [b11m,b12p,b3,-2],
        [b11m,b12p,bt3,2],
        [b12m,b11p,b3,2],
        [b12m,b11p,bt3,-2],
        [b22m,b21p,b3,2],
        [b22m,b21p,bt3,2],
        [b21m,b22p,b3,-2],
        [b21m,b22p,bt3,-2],
        [b22p,b11p,bp,-2],
        [b21p,b12p,bp,2],
        [b22m,b11m,bm,2],
        [b21m,b12m,bm,-2],
        [b22m,b11p,btp,2],
        [b21m,b12p,btp,-2],
        [b22p,b11m,btm,-2],
        [b21p,b12m,btm,2],
        [b12p,b3,b12p,0.5],
        [b12m,b3,b12m,-0.5],
        [b11p,b3,b11p,-0.5],
        [b11m,b3,b11m,0.5],
        [b22m,b3,b22m,-0.5],
        [b22p,b3,b22p,0.5],
        [b21m,b3,b21m,0.5],
        [b21p,b3,b21p,-0.5],
        [b12m,bp,b22p,1],
        [b11m,bp,b21p,-1],
        [b22m,bp,b12p,-1],
        [b21m,bp,b11p,1],
        [b12p,bm,b22m,-1],
        [b11p,bm,b21m,1],
        [b22p,bm,b12m,1],
        [b21p,bm,b11m,-1],
        [b12p,bt3,b12p,0.5],
        [b12m,bt3,b12m,-0.5],
        [b11p,bt3,b11p,-0.5],
        [b11m,bt3,b11m,0.5],
        [b22m,bt3,b22m,0.5],
        [b22p,bt3,b22p,-0.5],
        [b21m,bt3,b21m,-0.5],
        [b21p,bt3,b21p,0.5],
        [b12m,btp,b22m,1],
        [b11m,btp,b21m,-1],
        [b21p,btp,b11p,1],
        [b22p,btp,b12p,-1],
        [b11p,btm,b21p,1],
        [b12p,btm,b22p,-1],
        [b21m,btm,b11m,-1],
        [b22m,btm,b12m,1]
        ]

    
    for term in cubics:
        if term[0] in operand and term[1] in operand:
            coeff,temp = operand.killGhost(term[0])
            coeff1,temp1 = temp.killGhost(term[1])
            coeff2,result = temp1.addGhost(term[2])
            if result.isLegal():
                final.append([term[3]*coeff*coeff1*coeff2,result])
            


    return final


class cohomResult(list):
    def __init__(self,start):
        self[:] = start
        self.key = []
        self.states = []

    def addColumn(self):
        for row in self:
            row+=[0]
        return 0
    
    def addRow(self):
        self.append([0]*len(self.key))




def recur(valueNum,current,depth,vector,ghostList):
    if current == depth:
        opItem = operator(vector)
        if opItem.fastLegal(valueNum):
            opItem.sortNice()
            if opItem not in ghostList:
                ghostList.append(opItem)
    else:
        for x in ghosts:
            newList = vector[:]
            newList.append(x)
            recur(valueNum,current+1,depth,newList,ghostList)




def generateStates(ghostNum,valueNum):
    ghostList = []
    recur(valueNum,0,ghostNum,[],ghostList)

    A =  cohomResult([])

    
    for opItem in  ghostList:

        opItem.addMatter(valueNum)

        # reset totals after adding matter
        opItem.totals()

        if opItem.itotal!=1:
            print "eek, bug here!",opItem
            continue
        if opItem.jtotal!=-1:
            print "eek, bug here!",opItem
            continue
        if opItem.value!=valueNum:
            print "eek, bug here!",opItem
            continue

        A.states.append(opItem)

        image = Q(opItem)

        
        for element in image:
            element[1].totals()
            if element[1].itotal-1!= 0:
                print "yikes with ",element[1]
            if element[1].jtotal+1!= 0:
                print "yikes with ",element[1]
            if element[1].value-valueNum!= 0:
                print "yikes with ",element[1]

            tempDum = 0
            for letters in ghosts:
                tempDum+=element[1].count(letters)

            if tempDum!=ghostNum-1:
                print "yikes at",element[1],tempDum

            if element[1] not in A.key:
                A.key.append(element[1])
                A.addColumn()

        rowToAdd = [0]*len(A.key)

        for element in image:
            position = A.key.index(element[1])
            rowToAdd[position] += element[0]
        

        A.append(rowToAdd)
        
    for i in range(0,len(A)):
        for j in range(0,len(A.key)):
            if A[i][j]-int(A[i][j])!=0:
                print "beware non-integer entries in A"
            A[i][j] = int(A[i][j])

    if len(A)!=len(A.states):
        print "error! length of states is different from length of A"
    if len(A)>1:
        if len(A[0])!=len(A.key):
            print "error! length of row not equal to key"


    return A
    



def processStates(ghostNum,valueNum):

    listGhostsOnly=[]

    A =  cohomResult([])

    for item in combinations(ghostNum):
        opItem = operator(item)
        if not opItem.isVeryLegal(valueNum):
            continue
        opItem.sortNice()
        if opItem not in listGhostsOnly:
            listGhostsOnly.append(opItem[:])
        else:
            continue

        opItem.addMatter(valueNum)

        # reset totals after adding matter
        opItem.totals()

        if opItem.itotal!=1:
            print "eek, bug here!",opItem
            continue
        if opItem.jtotal!=-1:
            print "eek, bug here!",opItem
            continue
        if opItem.value!=valueNum:
            print "eek, bug here!",opItem
            continue

        A.states.append(opItem)

        image = Q(opItem)

        
        for element in image:
            element[1].totals()
            if element[1].itotal-1!= 0:
                print "yikes with ",element[1]
            if element[1].jtotal+1!= 0:
                print "yikes with ",element[1]
            if element[1].value-valueNum!= 0:
                print "yikes with ",element[1]

            tempDum = 0
            for letters in ghosts:
                tempDum+=element[1].count(letters)

            if tempDum!=ghostNum-1:
                print "yikes at",element[1],tempDum

            if element[1] not in A.key:
                A.key.append(element[1])
                A.addColumn()

        rowToAdd = [0]*len(A.key)

        for element in image:
            position = A.key.index(element[1])
            rowToAdd[position] += element[0]
        

        A.append(rowToAdd)
        
    for i in range(0,len(A)):
        for j in range(0,len(A.key)):
            if A[i][j]-int(A[i][j])!=0:
                print "beware non-integer entries in A"
            A[i][j] = int(A[i][j])

    if len(A)!=len(A.states):
        print "error! length of states is different from length of A"
    if len(A)>1:
        if len(A[0])!=len(A.key):
            print "error! length of row not equal to key"


    return A
#    if A!=[]:
#        print A
#        print A.key
#        nMatrix = numpy.matrix(A)
#        rank =  numpy.linalg.matrix_rank(nMatrix)
#        print "length of key is", len(A.key)
#        print "rank of A is", rank
#        print "so size of kernel is", counter - rank
#    else:
#        print "so size of kernel is",counter


if __name__ == "__main__":


    if len(sys.argv)!=3:
        print "error: require a ghost number argument and a second index value"
        sys.exit(0)

    ghostNum = int(sys.argv[1])
    valueNum = int(sys.argv[2])

    # the second index value
    #valueNum = 1+2*((ghostNum-1)/2)

    print "ghost number is",ghostNum
    print "second index value is",valueNum

    A = generateStates(ghostNum,valueNum)

    outputFile = open("gibbon.sage", 'w')
    outputFile.write("total = " + str(len(A.states)) + "\n\n")
    outputFile.write("A = " + str(A)+ "\n\n")
    outputFile.write("Amat = matrix(A)"+ "\n\n")
    outputFile.write("states =" + str(A.states) + "\n\n")
    outputFile.write("key =" + str(A.key) + "\n\n")
    outputFile.close()


    print "there are",len(A.states),"states at ghost number",ghostNum,"and value",valueNum


