import sys


class letter(object):
    def __init__(self,name):
        self.name = name


    def __repr__(self):
        return self.name

class algebra(letter):
    pass


class ghost(letter):
    pass








S11p = algebra("S11p")
S11p.j = 1
S11p.i = 1
S11p.f = 1

S11m = algebra("S11m")
S11m.j = -1
S11m.i = -1
S11m.f = 1

S12p = algebra("S12p")
S12p.j = 1
S12p.i = 1
S12p.f = 1

S12m = algebra("S12m")
S12m.j = -1
S12m.i = -1
S12m.f = 1


S21p = algebra("S21p")
S21p.j = 1
S21p.i = -1
S21p.f = 1

S21m = algebra("S21m")
S21m.j = -1
S21m.i = 1
S21m.f = 1

S22p = algebra("S22p")
S22p.j = 1
S22p.i = -1
S22p.f = 1

S22m = algebra("S22m")
S22m.j = -1
S22m.i = 1
S22m.f = 1




Jp = algebra("Jp")
Jp.j = 2
Jp.i = 0
Jp.f = 0

J3 = algebra("J3")
J3.j = 0
J3.i = 0
J3.f = 0

Jm = algebra("Jm")
Jm.j = -2
Jm.i = 0
Jm.f = 0



Jtp = algebra("Jtp")
Jtp.j = 0
Jtp.i = 2
Jtp.f = 0

Jt3 = algebra("Jt3")
Jt3.j = 0
Jt3.i = 0
Jt3.f = 0

Jtm = algebra("Jtm")
Jtm.j = 0
Jtm.i = -2
Jtm.f = 0



bp = ghost("bp")
bp.j = 2
bp.i = 0
bp.f = 1

b3 = ghost("b3")
b3.j = 0
b3.i = 0
b3.f = 1

bm = ghost("bm")
bm.j = -2
bm.i = 0
bm.f = 1



btp = ghost("btp")
btp.j = 0
btp.i = 2
btp.f = 1

bt3 = ghost("bt3")
bt3.j = 0
bt3.i = 0
bt3.f = 1

btm = ghost("btm")
btm.j = 0
btm.i = -2
btm.f = 1


b11p = ghost("b11p")
b11p.j = 1
b11p.i = 1
b11p.f = 0

b11m = ghost("b11m")
b11m.j = -1
b11m.i = -1
b11m.f = 0

b12p = ghost("b12p")
b12p.j = 1
b12p.i = 1
b12p.f = 0

b12m = ghost("b12m")
b12m.j = -1
b12m.i = -1
b12m.f = 0


b21p = ghost("b21p")
b21p.j = 1
b21p.i = -1
b21p.f = 0

b21m = ghost("b21m")
b21m.j = -1
b21m.i = 1
b21m.f = 0

b22p = ghost("b22p")
b22p.j = 1
b22p.i = -1
b22p.f = 0

b22m = ghost("b22m")
b22m.j = -1
b22m.i = 1
b22m.f = 0



ghosts = [bp,b3,bm,btp,bt3,btm,b11p,b11m,b21p,b21m,b12p,b12m,b22p,b22m]

algebras = [S11p,S11m,S21p,S21m,S12p,S12m,S22p,S22m,Jp,J3,Jm,Jtp,Jt3,Jtm]


ones = [b11m,b11p,b21m,b21p,S11m,S11p,S21m,S21p]
twos = [b12m,b12p,b22m,b22p,S12m,S12p,S22m,S22p]




#defined sorting order
counter = 1
for letter in ghosts + algebras:
    letter.order = counter
    counter+=1



def isodd(number):
    return number - 2*(number/2)



class operator(list):


    def sortNice(self):
        self.sort(key=lambda goat: goat.order)

    def totals(self):
        self.jtotal = 0
        self.itotal = 0
        self.value = 0


        for item in self:
            self.jtotal+=item.j
            self.itotal+=item.i
            if item in ones:
                self.value+=1
            elif item in twos:
                self.value-=1



    def countFermions(self):
        result = 0
        for item in self:
            result+=item.f

        return result


    #check no duplicated fermionic ghosts
    def fermionicGhostsLegal(self):

        for item in ghosts:
            if self.count(item)>1 and item.f==1:
                return 0


        return 1



    #limited but not comprehensive check that ghosts are legal
    def ghostsSemiLegal(self,valueNum):
        self.jtotal = 0
        self.itotal = 0

        for item in self:
            self.jtotal+=item.j
            self.itotal+=item.i



        if self.jtotal>=3:
            return 0

        if self.jtotal<=-3:
            return 0

        if self.itotal>=3:
            return 0

        if self.itotal<=-3:
            return 0


        self.value = 0


        for item in self:
            if item in ones:
                self.value+=1
            elif item in twos:
                self.value-=1

        if self.value>=valueNum+2:
            return 0

        if self.value<=valueNum-2:
            return 0



        return 1



    def stateIsLegal(self,valueNum):
        

        self.totals()

        if self.jtotal!=0:
            print "j charge of",self,"is wrong"
            return 0
        if self.itotal!=0:
            print "i charge of",self,"is wrong"
            return 0
        if self.value!=valueNum:
            print "value of",self,"is wrong"
            return 0


        for item in ghosts + algebras:
            if self.count(item)>1 and item.f==1:
                print "more than one fermion",item
                return 0


        return 1

     


    def killGhost(self,toKill):
        result=operator(self[:])        
        if toKill.f==1:
            coeff = (-1)**operator(result[:result.index(toKill)]).countFermions()
        else:
            if toKill in ones:
                coeff = -result.count(toKill)
            elif toKill in twos:
                coeff = result.count(toKill)
            else:
                print "error!"

        result.remove(toKill)
        
        return coeff,result


    def addGhost(self,toAdd):
        result = operator(self[:])
        result.append(toAdd)
        result.sortNice()
        if toAdd.f==1:
            sign = (-1)**operator(result[:result.index(toAdd)]).countFermions()
        else:
            sign = 1

        return sign,result




quadratic = [
    [b3,J3,1],
    [bp,Jm,0.5],
    [bm,Jp,0.5],
    [bt3,Jt3,1],
    [btp,Jtm,0.5],
    [btm,Jtp,0.5],
    [b12p,S11m,-1],
    [b11p,S12m,1],
    [b12m,S11p,-1],
    [b11m,S12p,1],
    [b22p,S21m,-1],
    [b21p,S22m,1],
    [b22m,S21p,-1],
    [b21m,S22p,1]
    ]
commutators = [
    [J3,Jp,Jp,1],
    [J3,Jm,Jm,-1],
    [Jt3,Jtp,Jtp,1],
    [Jt3,Jtm,Jtm,-1],
    [J3,S11p,S11p,0.5],
    [J3,S12p,S12p,0.5],
    [J3,S21p,S21p,0.5],
    [J3,S22p,S22p,0.5],
    [J3,S11m,S11m,-0.5],
    [J3,S12m,S12m,-0.5],
    [J3,S21m,S21m,-0.5],
    [J3,S22m,S22m,-0.5],
    [Jt3,S11p,S11p,0.5],
    [Jt3,S12p,S12p,0.5],
    [Jt3,S21p,S21p,-0.5],
    [Jt3,S22p,S22p,-0.5],
    [Jt3,S11m,S11m,-0.5],
    [Jt3,S12m,S12m,-0.5],
    [Jt3,S21m,S21m,0.5],
    [Jt3,S22m,S22m,0.5],
    [S11p,S22p,Jp,-2],
    [S12p,S21p,Jp,2],
    [S11m,S22m,Jm,2],
    [S12m,S21m,Jm,-2],
    [S11p,S22m,Jtp,2],
    [S12p,S21m,Jtp,-2],
    [S11m,S22p,Jtm,-2],
    [S12m,S21p,Jtm,2],
    [Jp,S11m,S21p,1],
    [Jp,S12m,S22p,1],
    [Jm,S11p,S21m,-1],
    [Jm,S12p,S22m,-1],
    [Jp,S21m,S11p,-1],
    [Jp,S22m,S12p,-1],
    [Jm,S21p,S11m,1],
    [Jm,S22p,S12m,1],
    [Jtp,S11m,S21m,1],
    [Jtp,S12m,S22m,1],
    [Jtm,S11p,S21p,-1],
    [Jtm,S12p,S22p,-1],
    [Jtp,S21p,S11p,-1],
    [Jtp,S22p,S12p,-1],
    [Jtm,S21m,S11m,1],
    [Jtm,S22m,S12m,1],
    [Jp,Jm,J3,2],
    [Jtp,Jtm,Jt3,2],
    [S11p,S12m,J3,2],
    [S11p,S12m,Jt3,-2],
    [S12p,S11m,J3,-2],
    [S12p,S11m,Jt3,2],
    [S21p,S22m,J3,2],
    [S21p,S22m,Jt3,2],
    [S22p,S21m,J3,-2],
    [S22p,S21m,Jt3,-2],
    ]


def Q(operand):
    final = []


    for item in quadratic:
        if True:
            for term in commutators:
                if term[0]==item[1] and term[1] in operand:
                    coeff,result = operand.addGhost(item[0])
                    coeff2 = term[3]*item[2]

                    result.remove(term[1])

                    #fix sign for shuffling past ghosts
                    if term[0].f==1:
                        coeff3 = (-1)**result.countFermions()
                    else:
                        coeff3 = 1
                    result.append(term[2])
                    if result.fermionicGhostsLegal():
                        final.append([coeff*coeff2*coeff3,result])

                elif term[1]==item[1] and term[0] in operand:
                    coeff,result = operand.addGhost(item[0])

                    #fix sign of commutator
                    if term[0].f==1 and term[1].f==1:
                        sign = 1
                    else:
                        sign = -1
                    coeff2 = sign*term[3]*item[2]
                    result.remove(term[0])

                    #fix sign for shuffling past ghosts
                    if term[1].f==1:
                        coeff3 = (-1)**result.countFermions()
                    else:
                        coeff3 = 1
                    result.append(term[2])
                    if result.fermionicGhostsLegal():
                        final.append([coeff*coeff2*coeff3,result])



    # now for the cubic terms


    #term in cubic corresponds to (coefficient term[3])*(b ghost
    #term[2])*(c cong of term[1])*(c cong of term[0])
    #coefficient term[3] includes and 2 from {c^+,b-} = 2

    cubics = [
        [bp,bm,b3,0.5],
        [b3,bp,bp,1],
        [bm,b3,bm,1],
        [btp,btm,bt3,0.5],
        [bt3,btp,btp,1],
        [btm,bt3,btm,1],
        [b11m,b12p,b3,-2],
        [b11m,b12p,bt3,2],
        [b12m,b11p,b3,2],
        [b12m,b11p,bt3,-2],
        [b22m,b21p,b3,2],
        [b22m,b21p,bt3,2],
        [b21m,b22p,b3,-2],
        [b21m,b22p,bt3,-2],
        [b22p,b11p,bp,-4],
        [b21p,b12p,bp,4],
        [b22m,b11m,bm,4],
        [b21m,b12m,bm,-4],
        [b22m,b11p,btp,4],
        [b21m,b12p,btp,-4],
        [b22p,b11m,btm,-4],
        [b21p,b12m,btm,4],
        [b12p,b3,b12p,0.5],
        [b12m,b3,b12m,-0.5],
        [b11p,b3,b11p,-0.5],
        [b11m,b3,b11m,0.5],
        [b22m,b3,b22m,-0.5],
        [b22p,b3,b22p,0.5],
        [b21m,b3,b21m,0.5],
        [b21p,b3,b21p,-0.5],
        [b12m,bp,b22p,0.5],
        [b11m,bp,b21p,-0.5],
        [b22m,bp,b12p,-0.5],
        [b21m,bp,b11p,0.5],
        [b12p,bm,b22m,-0.5],
        [b11p,bm,b21m,0.5],
        [b22p,bm,b12m,0.5],
        [b21p,bm,b11m,-0.5],
        [b12p,bt3,b12p,0.5],
        [b12m,bt3,b12m,-0.5],
        [b11p,bt3,b11p,-0.5],
        [b11m,bt3,b11m,0.5],
        [b22m,bt3,b22m,0.5],
        [b22p,bt3,b22p,-0.5],
        [b21m,bt3,b21m,-0.5],
        [b21p,bt3,b21p,0.5],
        [b12m,btp,b22m,0.5],
        [b11m,btp,b21m,-0.5],
        [b21p,btp,b11p,0.5],
        [b22p,btp,b12p,-0.5],
        [b11p,btm,b21p,0.5],
        [b12p,btm,b22p,-0.5],
        [b21m,btm,b11m,-0.5],
        [b22m,btm,b12m,0.5]
        ]

    
    for term in cubics:
        if term[2] in operand:
            coeff,temp = operand.killGhost(term[2])
            coeff1,temp1 = temp.addGhost(term[1])
            coeff2,result = temp1.addGhost(term[0])
            if result.fermionicGhostsLegal():
                final.append([term[3]*coeff*coeff1*coeff2,result])
            

    return final





def recurBoson(valueNum,current,toAdd,vector,ghostList):
    if current == len(toAdd):
        opItem = operator(vector)
        if opItem.ghostsSemiLegal(valueNum):
            opItem.sortNice()
            if opItem not in ghostList:
                ghostList.append(opItem)
    else:
        for x in toAdd[current]:
            newList = vector[:]
            newList.append(x)
            recurBoson(valueNum,current+1,toAdd,newList,ghostList)



def generateFermions(fermionList):
    resultList = [[]]
    for item in fermionList:
        tempList = resultList[:]
        resultList=[]
        for teilchen in tempList:
            resultList.append(teilchen)
            resultList.append(teilchen+[item])


    return resultList


def enumerateGhosts(ghostNum,valueNum):

    ghostList = []

    fermionCombos = generateFermions(ghosts[0:6])

    for fermionCombo in fermionCombos:

        fermionNumber = len(fermionCombo)
        if fermionNumber<=ghostNum:
            bosonNumber = ghostNum-fermionNumber


                
            for n in range(0,ghostNum+1):
                #this does the case for (Jtp)^{0,1} (Jp)^?
                if bosonNumber == 2*n+valueNum:
                    recurBoson(valueNum,0,[ghosts[6:10]]*(n+valueNum)+[ghosts[10:14]]*n,fermionCombo,ghostList)
                #this is for S12p (Jp)^?
                elif bosonNumber == 2*n+valueNum+1:
                    recurBoson(valueNum,0,[ghosts[6:10]]*(n+valueNum+1)+[ghosts[10:14]]*n,fermionCombo,ghostList)
                #this is for S11p (Jp)^?
                elif bosonNumber == 2*n+valueNum-1:
                    recurBoson(valueNum,0,[ghosts[6:10]]*(n+valueNum-1)+[ghosts[10:14]]*n,fermionCombo,ghostList)
    return ghostList





def generateStates(ghostNum,valueNum):


    ghostList = enumerateGhosts(ghostNum,valueNum)

    states = []
    for opItem in  ghostList:

        toggle = 0

        jToDo = -opItem.jtotal
        iToDo = -opItem.itotal
        valueToDo = valueNum-opItem.value

        if valueToDo==0:
            for representative in algebras[8:]:
                if representative.j==jToDo and representative.i==iToDo:
                    toAdd=operator(opItem[:])
                    toAdd.append(representative)
                    toAdd.sortNice()
                    states.append(toAdd)
                    toggle = 1
        elif valueToDo==1:
            for representative in algebras[0:4]:
                if representative.j==jToDo and representative.i==iToDo:
                    toAdd=operator(opItem[:])
                    toAdd.append(representative)
                    toAdd.sortNice()
                    states.append(toAdd)
                    toggle = 1
        elif valueToDo==-1:
            for representative in algebras[4:8]:
                if representative.j==jToDo and representative.i==iToDo:
                    toAdd=operator(opItem[:])
                    toAdd.append(representative)
                    toAdd.sortNice()
                    states.append(toAdd)
                    toggle = 1
            





#        if toggle==0:
#            print "not used:",opItem



    return states



class Qresult(list):
    def __init__(self,start):
        self[:] = start
        self.key = []
        self.states = []

    def addColumn(self):
        for row in self:
            row+=[0]
        return 0
    
    def addRow(self):
        self.append([0]*len(self.key))






# returns matrix of Q
def Qmatrix(ghostNum,valueNum):
    result =  Qresult([])

    states = generateStates(ghostNum,valueNum)

    for item in states:

        if not item.stateIsLegal(valueNum):
            print "state",item,"isn't legal"
            continue

        result.states.append(item)

        image = Q(item)

        
        for element in image:
            if not element[1].stateIsLegal(valueNum):
                print "error,",element[1],"in image of",item,"is not legal"

            tempDum = 0
            for letters in ghosts:
                tempDum+=element[1].count(letters)

            if tempDum!=ghostNum+1:
                print "wrong ghost number in",element[1],tempDum

            if element[1] not in result.key:
                result.key.append(element[1])
                result.addColumn()

        rowToAdd = [0]*len(result.key)

        for element in image:
            position = result.key.index(element[1])
            rowToAdd[position] += element[0]
        

        result.append(rowToAdd)
        
    for i in range(0,len(result)):
        for j in range(0,len(result.key)):
            #to avoid non-integer values from 0.5
            result[i][j]=2*result[i][j]
            if result[i][j]-int(result[i][j])!=0:
                print "program won't work because non-integer entries in result",result[i][j],int(result[i][j])
            result[i][j] = int(result[i][j])

    if len(result)!=len(result.states):
        print "error! length of states is different from length of result"
    if len(result)>1:
        if len(result[0])!=len(result.key):
            print "error! length of row not equal to key"


    return result





if __name__ == "__main__":


    if len(sys.argv)!=3:
        print "error: require a label for the atypical, a ghost number argument and a second index value"
        sys.exit(0)

    ghostNum = int(sys.argv[1])
    valueNum = int(sys.argv[2])


    print "ghost number is",ghostNum
    print "second index value is",valueNum

    A = Qmatrix(ghostNum,valueNum)

    print "that is a total of",len(A.states),"states"
#    print "maximum size of image is",len(A.key)


    outputFile = open("matrix.sage", 'w')
    outputFile.write("total = " + str(len(A.states)) + "\n\n")
    outputFile.write("A = matrix(" + str(A)+ ")\n\n")
    outputFile.close()

