

from BRSTevenfaster import *


if __name__ == "__main__":


    if len(sys.argv)!=3:
        print "error: require a ghost number argument and a second index value"
        sys.exit(0)

    ghostNum = int(sys.argv[1])
    valueNum = int(sys.argv[2])

    # the second index value
    #valueNum = 1+2*((ghostNum-1)/2)

    print "computing cohomology"
    print "ghost number is",ghostNum
    print "second index value is",valueNum


    A = generateStates(ghostNum,valueNum)
    B = generateStates(ghostNum+1,valueNum)


    outputFile = open("cohomology.sage", 'w')
    outputFile.write("A = cohomResult(" + str(A) + ")\n\n")
    outputFile.write("A.states = " + str(A.states) + "\n\n")
    outputFile.write("A.key = " + str(A.key) + "\n\n")
    outputFile.write("B = cohomResult(" + str(B) + ")\n\n")
    outputFile.write("B.states = " + str(B.states) + "\n\n")
    outputFile.write("B.key = " + str(B.key) + "\n\n")
    outputFile.close()


    print "there are",len(A.states),"states at ghost number",ghostNum,"and value",valueNum
    print "there are",len(B.states),"states at ghost number",ghostNum+1,"and value",valueNum

#    print A.key
#    print A
