
import sys,numpy


#n labels the discrete series atypicals
nthAtypical = 0


class letter(object):
    def __init__(self,name):
        self.name = name


    def __repr__(self):
        return self.name

class algebra(letter):
    pass


class ghost(letter):
    pass








S11p = algebra("S11p")
S11p.j = 1
S11p.i = 1
S11p.f = 1

S11m = algebra("S11m")
S11m.j = -1
S11m.i = -1
S11m.f = 1

S12p = algebra("S12p")
S12p.j = 1
S12p.i = 1
S12p.f = 1

S12m = algebra("S12m")
S12m.j = -1
S12m.i = -1
S12m.f = 1


S21p = algebra("S21p")
S21p.j = 1
S21p.i = -1
S21p.f = 1

S21m = algebra("S21m")
S21m.j = -1
S21m.i = 1
S21m.f = 1

S22p = algebra("S22p")
S22p.j = 1
S22p.i = -1
S22p.f = 1

S22m = algebra("S22m")
S22m.j = -1
S22m.i = 1
S22m.f = 1




Jp = algebra("Jp")
Jp.j = 2
Jp.i = 0
Jp.f = 0

J3 = algebra("J3")
J3.j = 0
J3.i = 0
J3.f = 0

Jm = algebra("Jm")
Jm.j = -2
Jm.i = 0
Jm.f = 0



Jtp = algebra("Jtp")
Jtp.j = 0
Jtp.i = 2
Jtp.f = 0

Jt3 = algebra("Jt3")
Jt3.j = 0
Jt3.i = 0
Jt3.f = 0

Jtm = algebra("Jtm")
Jtm.j = 0
Jtm.i = -2
Jtm.f = 0



bp = ghost("bp")
bp.j = 2
bp.i = 0
bp.f = 1

b3 = ghost("b3")
b3.j = 0
b3.i = 0
b3.f = 1

bm = ghost("bm")
bm.j = -2
bm.i = 0
bm.f = 1



btp = ghost("btp")
btp.j = 0
btp.i = 2
btp.f = 1

bt3 = ghost("bt3")
bt3.j = 0
bt3.i = 0
bt3.f = 1

btm = ghost("btm")
btm.j = 0
btm.i = -2
btm.f = 1


b11p = ghost("b11p")
b11p.j = 1
b11p.i = 1
b11p.f = 0

b11m = ghost("b11m")
b11m.j = -1
b11m.i = -1
b11m.f = 0

b12p = ghost("b12p")
b12p.j = 1
b12p.i = 1
b12p.f = 0

b12m = ghost("b12m")
b12m.j = -1
b12m.i = -1
b12m.f = 0


b21p = ghost("b21p")
b21p.j = 1
b21p.i = -1
b21p.f = 0

b21m = ghost("b21m")
b21m.j = -1
b21m.i = 1
b21m.f = 0

b22p = ghost("b22p")
b22p.j = 1
b22p.i = -1
b22p.f = 0

b22m = ghost("b22m")
b22m.j = -1
b22m.i = 1
b22m.f = 0



ghosts = [bp,b3,bm,btp,bt3,btm,b11p,b11m,b21p,b21m,b12p,b12m,b22p,b22m]

algebras = [S11p,S11m,S21p,S21m,S12p,S12m,S22p,S22m,Jp,J3,Jm,Jtp,Jt3,Jtm]


ones = [b11m,b11p,b21m,b21p,S11m,S11p,S21m,S21p]
twos = [b12m,b12p,b22m,b22p,S12m,S12p,S22m,S22p]


#defined sorting order
counter = 1
for letter in algebras + ghosts:
    letter.order = counter
    counter+=1



def isodd(number):
    return number - 2*(number/2)



class operator(list):


    def sortNice(self):
        self.sort(key=lambda goat: goat.order)

    def totals(self):
        self.jtotal = 0
        self.itotal = 0
        self.value = 0


        for item in self:
            self.jtotal+=item.j
            self.itotal+=item.i
            if item in ones:
                self.value+=1
            elif item in twos:
                self.value-=1



    def countFermions(self):
        result = 0
        for item in self:
            result+=item.f

        return result


    #check no duplicated fermionic ghosts
    def fermionicGhostsLegal(self):

        for item in ghosts:
            if self.count(item)>1 and item.f==1:
                return 0


        return 1



    #limited but not comprehensive check that ghosts are legal
    def ghostsSemiLegal(self,valueNum):
        self.jtotal = 0
        self.itotal = 0

        for item in self:
            self.jtotal+=item.j
            self.itotal+=item.i



        if self.jtotal>=1-nthAtypical:
            return 0

        if self.itotal>=nthAtypical+1:
            return 0

        if self.itotal<=-nthAtypical-1:
            return 0


        self.value = 0


        for item in self:
            if item in ones:
                self.value+=1
            elif item in twos:
                self.value-=1

        if self.value>=valueNum+2:
            return 0

        if self.value<=valueNum-2:
            return 0



        return 1



    def stateIsLegal(self,valueNum):
        

        self.totals()

        if self.jtotal!=-nthAtypical:
            print "j charge of",self,"is wrong"
            return 0
        if self.itotal!=nthAtypical:
            print "i charge of",self,"is wrong"
            return 0
        if self.value!=valueNum:
            print "value of",self,"is wrong"
            return 0


        for item in ghosts + algebras:
            if self.count(item)>1 and item.f==1:
                print "more than one fermion",item
                return 0


        return 1

     


    def killGhost(self,toKill):
        result=operator(self[:])        
        if toKill.f==1:
            coeff = (-1)**operator(result[:result.index(toKill)]).countFermions()
        else:
            if toKill in ones:
                coeff = -result.count(toKill)
            elif toKill in twos:
                coeff = result.count(toKill)
            else:
                print "error!"

        result.remove(toKill)
        
        return coeff,result


    def addGhost(self,toAdd):
        result = operator(self[:])
        result.append(toAdd)
        result.sortNice()
        if toAdd.f==1:
            sign = (-1)**operator(result[:result.index(toAdd)]).countFermions()
        else:
            sign = 1

        return sign,result






#the BRST operator acts
def Q(operand):
    final = []

    #quadratic terms first

    #these are dealt with separately so that matter algebra can be
    #implemented by hand

    # remember to include sign; in general factors form {c^+,b^-} are included


    p = operand.count(Jtp)
    q = operand.count(Jp)

    if bp in operand:
        coeff,result = operand.killGhost(bp)
        result.insert(0,Jp)
        result.sortNice()
        final.append([coeff,result])


    if b3 in operand:
        coeff,result = operand.killGhost(b3)
        coeff2 = 0.5*nthAtypical + q + 0.5*result.count(S11p) + 0.5*result.count(S12p)
        final.append([coeff*coeff2,result])


    if bm in operand:
        coeff,result = operand.killGhost(bm)
        if S11p not in result and S12p not in result:
            if q==0:
                coeff2 = 0
            else:
                coeff2 = -(q*nthAtypical + q*q -q)
                result.remove(Jp)
        elif S11p in result and S12p not in result:
            if q==0:
                coeff2 = 0
            else:
                coeff2 = -(q*nthAtypical+q*q)
                result.remove(Jp)
        elif S11p not in result and S12p in result:
            if q==0:
                coeff2 = 0
            else:
                coeff2 = -(q*nthAtypical+q*q)
                result.remove(Jp)
        elif S11p in result and S12p in result:
            if q==0:
                coeff2 = 0
            else:
                coeff2 = -(q*nthAtypical +q*q +q)
                result.remove(Jp)
            coeff3,result2 = operand.killGhost(bm)
            result2.remove(S11p)
            result2.remove(S12p)
            result2.insert(0,Jtp)
            result2.sortNice()
            final.append([coeff3*2,result2])

        if coeff2!=0:
            final.append([coeff*coeff2,result])




    if btp in operand:
        coeff,result = operand.killGhost(btp)
        if S11p not in result and S12p not in result:
            if p < nthAtypical:
                coeff2 = 1
                result.insert(0,Jtp)
                result.sortNice()
            else:
                coeff2 = 0
        elif S11p in result and S12p not in result:
            if p < (nthAtypical - 1):
                coeff2 = 1
                result.insert(0,Jtp)
                result.sortNice()
            else:
                coeff2 = 0
        elif S11p not in result and S12p in result:
            if p < (nthAtypical - 1):
                coeff2 = 1
                result.insert(0,Jtp)
                result.sortNice()
            else:
                coeff2 = 0
        elif S11p in result and S12p in result:
            if p < (nthAtypical - 2):
                coeff2 = 1
                result.insert(0,Jtp)
                result.sortNice()
            elif p==(nthAtypical - 2):
                coeff2 = -2/float(nthAtypical)
                result.remove(S11p)
                result.remove(S12p)
                result.append(Jtp)
                result.append(Jtp)
                result.append(Jp)
                result.sortNice()

        if coeff2!=0:
            final.append([coeff*coeff2,result])



    if bt3 in operand:
        coeff,result = operand.killGhost(bt3)
        coeff2 = -0.5*nthAtypical + p + 0.5*result.count(S11p) + 0.5*result.count(S12p)
        final.append([coeff*coeff2,result])



    if btm in operand:
        coeff,result = operand.killGhost(btm)
        if S11p not in result and S12p not in result:
            if p==0:
                coeff2 = 0
            else:
                coeff2 = p*nthAtypical - p*p + p
                result.remove(Jtp)
        elif S11p in result and S12p not in result:
            if p==0:
                coeff2 = 0
            else:
                coeff2 = p*nthAtypical - p*p
                result.remove(Jtp)
        elif S11p not in result and S12p in result:
            if p==0:
                coeff2 = 0
            else:
                coeff2 = p*nthAtypical - p*p
                result.remove(Jtp)
        elif S11p in result and S12p in result:
            if p==0:
                coeff2 = 0
            else:
                coeff2 = p*nthAtypical - p*p - p
                result.remove(Jtp)
            coeff3,result2 = operand.killGhost(btm)
            result2.remove(S11p)
            result2.remove(S12p)
            result2.insert(0,Jp)
            result2.sortNice()
            final.append([coeff3*(-2),result2])

        if coeff2!=0:
            final.append([coeff*coeff2,result])
                                     





    if b11p in operand:
        coeff,result = operand.killGhost(b11p)
        if S11p not in result and S12p not in result:
            if p==nthAtypical:
                coeff2 = 0
            else:
                coeff2 = 1
                result.insert(0,S11p)
        elif S11p in result and S12p not in result:
            coeff2 = 0
        elif S11p not in result and S12p in result:
            if p==(nthAtypical-1):
                coeff2 = -2/float(nthAtypical)
                result.remove(S12p)
                result.append(Jtp)
                result.append(Jp)
                result.sortNice()
            else:
                coeff2 = 1
                result.insert(0,S11p)
        elif S11p in result and S12p in result:
            coeff2 = 0
        
        if coeff2!=0:
            final.append([-1*coeff*coeff2,result])


    if b12p in operand:
        coeff,result = operand.killGhost(b12p)
        if S11p not in result and S12p not in result:
            if p==nthAtypical:
                coeff2 = 0
            else:
                coeff2 = 1
                result.insert(0,S12p)
        elif S11p in result and S12p not in result:
            if p==(nthAtypical-1):
                coeff2 = 2/float(nthAtypical)
                result.remove(S11p)
                result.append(Jtp)
                result.append(Jp)
                result.sortNice()
            else:
                coeff2 = -1
                result.insert(0,S12p)
                result.sortNice()
        elif S11p not in result and S12p in result:
            coeff2 = 0
        elif S11p in result and S12p in result:
            coeff2 = 0


        if coeff2 != 0:
            final.append([coeff*coeff2,result])


    if b21p in operand:
        coeff,result = operand.killGhost(b21p)
        if S11p not in result and S12p not in result:
            if p==0:
                coeff2 = 0
            else:
                coeff2 = p
                result.insert(0,S11p)
                result.remove(Jtp)
        elif S11p in result and S12p not in result:
            coeff2 = 0
        elif S11p not in result and S12p in result:
            if p==0:
                coeff2 = 0
            else:
                coeff2 = p
                result.insert(0,S11p)
                result.remove(Jtp)
            coeff3,result2 = operand.killGhost(b21p)
            result2.remove(S12p)
            result2.append(Jp)
            result2.sortNice()
            final.append([-1*coeff3*2,result2])
        elif S11p in result and S12p in result:
            coeff2 = -2
            result.remove(S12p)
            result.append(Jp)
            result.sortNice()

        if coeff2 != 0:
            final.append([-1*coeff*coeff2,result])


    if b22p in operand:
        coeff,result = operand.killGhost(b22p)

        if S11p not in result and S12p not in result:
            if p==0:
                coeff2 = 0
            else:
                coeff2 = p
                result.insert(0,S12p)
                result.remove(Jtp)
        elif S11p in result and S12p not in result:
            if p==0:
                coeff2 = 0
            else:
                coeff2 = -p
                result.remove(Jtp)
                result.insert(0,S12p)
                result.sortNice()
            coeff3,result2 = operand.killGhost(b22p)
            result2.remove(S11p)
            result2.append(Jp)
            result2.sortNice()
            final.append([coeff3*(-2),result2])
        elif S11p not in result and S12p in result:
            coeff2 = 0
        elif S11p in result and S12p in result:
            coeff2 = -2
            result.remove(S11p)
            result.append(Jp)
            result.sortNice()


        if coeff2!=0:
            final.append([coeff*coeff2,result])


    if b11m in operand:
        coeff,result = operand.killGhost(b11m)
        if S11p not in result and S12p not in result:
            if p==0 or q==0:
                coeff2 = 0
            else:
                coeff2 = -p*q
                result.insert(0,S11p)
                result.remove(Jtp)
                result.remove(Jp)
        elif S11p in result and S12p not in result:
            coeff2 = 0
        elif S11p not in result and S12p in result:
            if p==0 or q==0:
                coeff2 = 0
            else:
                coeff2 = -p*q
                result.insert(0,S11p)
                result.remove(Jtp)
                result.remove(Jp)
            coeff3,result2 = operand.killGhost(b11m)
            result2.remove(S12p)
            final.append([-1*coeff3*(-2*(nthAtypical+q-p)),result2])
        elif S11p in result and S12p in result:
            coeff2 = 2*(nthAtypical+q-p)
            result.remove(S12p)
        
        if coeff2!=0:
            final.append([-1*coeff*coeff2,result])


    if b12m in operand:
        coeff,result = operand.killGhost(b12m)
        if S11p not in result and S12p not in result:
            if p==0 or q==0:
                coeff2 = 0
            else:
                coeff2 = -p*q
                result.insert(0,S12p)
                result.remove(Jtp)
                result.remove(Jp)
        elif S11p in result and S12p not in result:
            if p==0 or q==0:
                coeff2 = 0
            else:
                coeff2 = p*q
                result.insert(0,S12p)
                result.remove(Jtp)
                result.remove(Jp)
                result.sortNice()
            coeff3,result2 = operand.killGhost(b12m)
            result2.remove(S11p)
            final.append([coeff3*2*(nthAtypical+q-p),result2])
        elif S11p not in result and S12p in result:
            coeff2 = 0
        elif S11p in result and S12p in result:
            coeff2 = 2*(nthAtypical+q-p)
            result.remove(S11p)

        if coeff2!=0:
            final.append([coeff*coeff2,result])


    if b21m in operand:
        coeff,result = operand.killGhost(b21m)
        if S11p not in result and S12p not in result:
            if p==nthAtypical:
                coeff2 = 0
            else:
                if q==0:
                    coeff2 = 0
                else:
                    coeff2 = q
                    result.insert(0,S11p)
                    result.remove(Jp)
        elif S11p in result and S12p not in result:
            coeff2 = 0
        elif S11p not in result and S12p in result:
            if p==(nthAtypical-1):
                coeff2 = -2 -2*q/float(nthAtypical)
                result.remove(S12p)
                result.append(Jtp)
                result.sortNice()
            else:
                if q==0:
                    coeff2 = 0
                else:
                    coeff2 = q
                    result.insert(0,S11p)
                    result.remove(Jp)
                coeff3,result2 = operand.killGhost(b21m)
                result2.remove(S12p)
                result2.append(Jtp)
                result2.sortNice()
                final.append([-1*coeff3*(-2),result2])

        elif S11p in result and S12p in result:
            coeff2 = 2
            result.remove(S12p)
            result.append(Jtp)
            result.sortNice()
        
        if coeff2!=0:
            final.append([-1*coeff*coeff2,result])

    
    if b22m in operand:
        coeff,result = operand.killGhost(b22m)
        if S11p not in result and S12p not in result:
            if p==nthAtypical:
                coeff2 = 0
            else:
                if q==0:
                    coeff2 = 0
                else:
                    coeff2 = q
                    result.insert(0,S12p)
                    result.remove(Jp)
        elif S11p in result and S12p not in result:
            if p==(nthAtypical-1):
                coeff2 = 2+2*q/float(nthAtypical)
                result.remove(S11p)
                result.append(Jtp)
                result.sortNice()
            else:
                if q==0:
                    coeff2 = 0
                else:
                    coeff2 = -q
                    result.append(S12p)
                    result.remove(Jp)
                    result.sortNice()
                coeff3,result2 = operand.killGhost(b22m)
                result2.remove(S11p)
                result2.append(Jtp)
                result2.sortNice()
                final.append([coeff3*2,result2])

        elif S11p not in result and S12p in result:
            coeff2 = 0

        elif S11p in result and S12p in result:
            coeff2 = 2
            result.remove(S11p)
            result.append(Jtp)
            result.sortNice()


        if coeff2!=0:
            final.append([coeff*coeff2,result])



    # now for the cubic terms


    #term in cubic corresponds to (coefficient term[3])*(b ghost
    #term[2])*(c cong of term[1])*(c cong of term[0])
    #coefficient term[3] includes and 2 from {c^+,b-} = 2

    cubics = [
        [bp,bm,b3,2],
        [b3,bp,bp,1],
        [bm,b3,bm,1],
        [btp,btm,bt3,2],
        [bt3,btp,btp,1],
        [btm,bt3,btm,1],
        [b11m,b12p,b3,-2],
        [b11m,b12p,bt3,2],
        [b12m,b11p,b3,2],
        [b12m,b11p,bt3,-2],
        [b22m,b21p,b3,2],
        [b22m,b21p,bt3,2],
        [b21m,b22p,b3,-2],
        [b21m,b22p,bt3,-2],
        [b22p,b11p,bp,-2],
        [b21p,b12p,bp,2],
        [b22m,b11m,bm,2],
        [b21m,b12m,bm,-2],
        [b22m,b11p,btp,2],
        [b21m,b12p,btp,-2],
        [b22p,b11m,btm,-2],
        [b21p,b12m,btm,2],
        [b12p,b3,b12p,0.5],
        [b12m,b3,b12m,-0.5],
        [b11p,b3,b11p,-0.5],
        [b11m,b3,b11m,0.5],
        [b22m,b3,b22m,-0.5],
        [b22p,b3,b22p,0.5],
        [b21m,b3,b21m,0.5],
        [b21p,b3,b21p,-0.5],
        [b12m,bp,b22p,1],
        [b11m,bp,b21p,-1],
        [b22m,bp,b12p,-1],
        [b21m,bp,b11p,1],
        [b12p,bm,b22m,-1],
        [b11p,bm,b21m,1],
        [b22p,bm,b12m,1],
        [b21p,bm,b11m,-1],
        [b12p,bt3,b12p,0.5],
        [b12m,bt3,b12m,-0.5],
        [b11p,bt3,b11p,-0.5],
        [b11m,bt3,b11m,0.5],
        [b22m,bt3,b22m,0.5],
        [b22p,bt3,b22p,-0.5],
        [b21m,bt3,b21m,-0.5],
        [b21p,bt3,b21p,0.5],
        [b12m,btp,b22m,1],
        [b11m,btp,b21m,-1],
        [b21p,btp,b11p,1],
        [b22p,btp,b12p,-1],
        [b11p,btm,b21p,1],
        [b12p,btm,b22p,-1],
        [b21m,btm,b11m,-1],
        [b22m,btm,b12m,1]
        ]

    
    for term in cubics:
        if term[0] in operand and term[1] in operand:
            coeff,temp = operand.killGhost(term[0])
            coeff1,temp1 = temp.killGhost(term[1])
            coeff2,result = temp1.addGhost(term[2])
            if result.fermionicGhostsLegal():
                final.append([term[3]*coeff*coeff1*coeff2,result])
            


    return final





def recurBoson(valueNum,current,toAdd,vector,ghostList):
    if current == len(toAdd):
        opItem = operator(vector)
        if opItem.ghostsSemiLegal(valueNum):
            opItem.sortNice()
            if opItem not in ghostList:
                ghostList.append(opItem)
    else:
        for x in toAdd[current]:
            newList = vector[:]
            newList.append(x)
            recurBoson(valueNum,current+1,toAdd,newList,ghostList)



def generateFermions(fermionList):
    resultList = [[]]
    for item in fermionList:
        tempList = resultList[:]
        resultList=[]
        for teilchen in tempList:
            resultList.append(teilchen)
            resultList.append(teilchen+[item])


    return resultList


def enumerateGhosts(ghostNum,valueNum):

    ghostList = []

    fermionCombos = generateFermions(ghosts[0:6])

    for fermionCombo in fermionCombos:

        fermionNumber = len(fermionCombo)
        if fermionNumber<=ghostNum:
            bosonNumber = ghostNum-fermionNumber


                
            for n in range(0,ghostNum+1):
                #this does the case for (Jtp)^{0,1} (Jp)^?
                if bosonNumber == 2*n+valueNum:
                    recurBoson(valueNum,0,[ghosts[6:10]]*(n+valueNum)+[ghosts[10:14]]*n,fermionCombo,ghostList)
                #this is for S12p (Jp)^?
                elif bosonNumber == 2*n+valueNum+1:
                    recurBoson(valueNum,0,[ghosts[6:10]]*(n+valueNum+1)+[ghosts[10:14]]*n,fermionCombo,ghostList)
                #this is for S11p (Jp)^?
                elif bosonNumber == 2*n+valueNum-1:
                    recurBoson(valueNum,0,[ghosts[6:10]]*(n+valueNum-1)+[ghosts[10:14]]*n,fermionCombo,ghostList)
    return ghostList





def generateStates(ghostNum,valueNum):


    ghostList = enumerateGhosts(ghostNum,valueNum)

    states = []
    for opItem in  ghostList:

        toggle = 0

        jToDo = -opItem.jtotal-nthAtypical
        iToDo = -opItem.itotal+nthAtypical

        if opItem.value==valueNum and not isodd(jToDo) and not isodd(iToDo) and jToDo >= 0 and iToDo>=0 and iToDo<=2*nthAtypical:
            toAdd = operator(opItem[:])
            toAdd.extend([Jp]*(jToDo/2)+[Jtp]*(iToDo/2))
            toAdd.sortNice()
            states.append(toAdd)
            toggle = 1

        jToDo-=1
        iToDo-=1

        if opItem.value==valueNum-1 and not isodd(jToDo) and not isodd(iToDo) and jToDo >= 0 and iToDo>=0 and iToDo<=2*nthAtypical-2:
            toAdd = operator(opItem[:])
            toAdd.extend([S11p]+[Jp]*(jToDo/2)+[Jtp]*(iToDo/2))
            toAdd.sortNice()
            states.append(toAdd)
            toggle = 1

        if opItem.value==valueNum+1 and not isodd(jToDo) and not isodd(iToDo) and jToDo >= 0 and iToDo>=0 and iToDo<=2*nthAtypical-2:
            toAdd = operator(opItem[:])
            toAdd.extend([S12p]+[Jp]*(jToDo/2)+[Jtp]*(iToDo/2))
            toAdd.sortNice()
            states.append(toAdd)
            toggle = 1

        jToDo-=1
        iToDo-=1

        if opItem.value==valueNum and not isodd(jToDo) and not isodd(iToDo) and jToDo >= 0 and iToDo>=0 and iToDo<=2*nthAtypical-4:
            toAdd = operator(opItem[:])
            toAdd.extend([S11p,S12p]+[Jp]*(jToDo/2)+[Jtp]*(iToDo/2))
            toAdd.sortNice()
            states.append(toAdd)
            toggle = 1

        if toggle==0:
            print "not used:",opItem



    return states



class Qresult(list):
    def __init__(self,start):
        self[:] = start
        self.key = []
        self.states = []

    def addColumn(self):
        for row in self:
            row+=[0]
        return 0
    
    def addRow(self):
        self.append([0]*len(self.key))



# returns matrix of Q
def Qmatrix(ghostNum,valueNum):
    result =  Qresult([])

    states = generateStates(ghostNum,valueNum)

    for item in states:

        if not item.stateIsLegal(valueNum):
            print "state",item,"isn't legal"
            continue

        result.states.append(item)

        image = Q(item)

        
        for element in image:
            if not element[1].stateIsLegal(valueNum):
                print "error,",element[1],"in image of",item,"is not legal"

            tempDum = 0
            for letters in ghosts:
                tempDum+=element[1].count(letters)

            if tempDum!=ghostNum-1:
                print "wrong ghost number in",element[1],tempDum

            if element[1] not in result.key:
                result.key.append(element[1])
                result.addColumn()

        rowToAdd = [0]*len(result.key)

        for element in image:
            position = result.key.index(element[1])
            rowToAdd[position] += element[0]
        

        result.append(rowToAdd)
        
    for i in range(0,len(result)):
        for j in range(0,len(result.key)):
            #to avoid non-integer values from 1/n
            result[i][j]=nthAtypical*result[i][j]
            if result[i][j]-int(result[i][j])!=0:
                print "program won't work because non-integer entries in result",result[i][j],int(result[i][j])
            result[i][j] = int(result[i][j])

    if len(result)!=len(result.states):
        print "error! length of states is different from length of result"
    if len(result)>1:
        if len(result[0])!=len(result.key):
            print "error! length of row not equal to key"


    return result




if __name__ == "__main__":


    if len(sys.argv)!=4:
        print "error: require a label for the atypical, a ghost number argument and a second index value"
        sys.exit(0)

    nthAtypical = int(sys.argv[1])
    ghostNum = int(sys.argv[2])
    valueNum = int(sys.argv[3])

    # the second index value
    #valueNum = 1+2*((ghostNum-1)/2)

    print "dealing with",nthAtypical,"th atypical"
    print "ghost number is",ghostNum
    print "second index value is",valueNum



    A = Qmatrix(ghostNum,valueNum)
    B = Qmatrix(ghostNum+1,valueNum)


    outputFile = open("cohomology.sage", 'w')
    outputFile.write("A = cohomResult(" + str(A) + ")\n\n")
    outputFile.write("A.states = " + str(A.states) + "\n\n")
    outputFile.write("A.key = " + str(A.key) + "\n\n")
    outputFile.write("B = cohomResult(" + str(B) + ")\n\n")
    outputFile.write("B.states = " + str(B.states) + "\n\n")
    outputFile.write("B.key = " + str(B.key) + "\n\n")
    outputFile.close()


    print "there are",len(A.states),"states at ghost number",ghostNum,"and value",valueNum
    print "there are",len(B.states),"states at ghost number",ghostNum+1,"and value",valueNum

