


class letter(object):
    def __init__(self,name):
        self.name = name


    def __repr__(self):
        return self.name

class algebra(letter):
    pass


class ghost(letter):
    pass








S11p = algebra("S11p")
S11p.j = 1
S11p.i = 1
S11p.f = 1

S11m = algebra("S11m")
S11m.j = -1
S11m.i = -1
S11m.f = 1

S12p = algebra("S12p")
S12p.j = 1
S12p.i = 1
S12p.f = 1

S12m = algebra("S12m")
S12m.j = -1
S12m.i = -1
S12m.f = 1


S21p = algebra("S21p")
S21p.j = 1
S21p.i = -1
S21p.f = 1

S21m = algebra("S21m")
S21m.j = -1
S21m.i = 1
S21m.f = 1

S22p = algebra("S22p")
S22p.j = 1
S22p.i = -1
S22p.f = 1

S22m = algebra("S22m")
S22m.j = -1
S22m.i = 1
S22m.f = 1




Jp = algebra("Jp")
Jp.j = 2
Jp.i = 0
Jp.f = 0

J3 = algebra("J3")
J3.j = 0
J3.i = 0
J3.f = 0

Jm = algebra("Jm")
Jm.j = -2
Jm.i = 0
Jm.f = 0



Jtp = algebra("Jtp")
Jtp.j = 0
Jtp.i = 2
Jtp.f = 0

Jt3 = algebra("Jt3")
Jt3.j = 0
Jt3.i = 0
Jt3.f = 0

Jtm = algebra("Jtm")
Jtm.j = 0
Jtm.i = -2
Jtm.f = 0



bp = ghost("bp")
bp.j = 2
bp.i = 0
bp.f = 1

b3 = ghost("b3")
b3.j = 0
b3.i = 0
b3.f = 1

bm = ghost("bm")
bm.j = -2
bm.i = 0
bm.f = 1



btp = ghost("btp")
btp.j = 0
btp.i = 2
btp.f = 1

bt3 = ghost("bt3")
bt3.j = 0
bt3.i = 0
bt3.f = 1

btm = ghost("btm")
btm.j = 0
btm.i = -2
btm.f = 1


b11p = ghost("b11p")
b11p.j = 1
b11p.i = 1
b11p.f = 0

b11m = ghost("b11m")
b11m.j = -1
b11m.i = -1
b11m.f = 0

b12p = ghost("b12p")
b12p.j = 1
b12p.i = 1
b12p.f = 0

b12m = ghost("b12m")
b12m.j = -1
b12m.i = -1
b12m.f = 0


b21p = ghost("b21p")
b21p.j = 1
b21p.i = -1
b21p.f = 0

b21m = ghost("b21m")
b21m.j = -1
b21m.i = 1
b21m.f = 0

b22p = ghost("b22p")
b22p.j = 1
b22p.i = -1
b22p.f = 0

b22m = ghost("b22m")
b22m.j = -1
b22m.i = 1
b22m.f = 0



ghosts = [bp,b3,bm,btp,bt3,btm,b11p,b11m,b21p,b21m,b12p,b12m,b22p,b22m]

algebras = [S11p,S11m,S21p,S21m,S12p,S12m,S22p,S22m,Jp,J3,Jm,Jtp,Jt3,Jtm]


ones = [b11m,b11p,b21m,b21p,S11m,S11p,S21m,S21p]
twos = [b12m,b12p,b22m,b22p,S12m,S12p,S22m,S22p]


#defined sorting order
counter = 1
for letter in algebras + ghosts:
    letter.order = counter
    counter+=1



def isodd(number):
    return number - 2*(number/2)

S1p = [S11p,S12p]
S1m = [S11m,S12m]
S2p = [S21p,S22p]
S2m = [S21m,S22m]






class operator(list):


    def sortNice(self):
        self.sort(key=lambda goat: goat.order)

    def totals(self):
        self.jtotal = 0
        self.itotal = 0
        self.value = 0


        for item in self:
            self.jtotal+=item.j
            self.itotal+=item.i
            if item in ones:
                self.value+=1
            elif item in twos:
                self.value-=1



    def countFermions(self):
        result = 0
        for item in self:
            result+=item.f

        return result


    #check no duplicated fermionic ghosts
    def fermionicGhostsLegal(self):

        for item in ghosts:
            if self.count(item)>1 and item.f==1:
                return 0


        return 1



    #limited but not comprehensive check that ghosts are legal
    def ghostsSemiLegal(self,valueNum):
        self.jtotal = 0
        self.itotal = 0

        for item in self:
            self.jtotal+=item.j
            self.itotal+=item.i



        if self.jtotal>=1-nthAtypical:
            return 0

        if self.itotal>=nthAtypical+1:
            return 0

        if self.itotal<=-nthAtypical-1:
            return 0


        self.value = 0


        for item in self:
            if item in ones:
                self.value+=1
            elif item in twos:
                self.value-=1

        if self.value>=valueNum+2:
            return 0

        if self.value<=valueNum-2:
            return 0



        return 1



    def stateIsLegal(self,valueNum):
        

        self.totals()

        if self.jtotal!=-nthAtypical:
            print "j charge of",self,"is wrong"
            return 0
        if self.itotal!=nthAtypical:
            print "i charge of",self,"is wrong"
            return 0
        if self.value!=valueNum:
            print "value of",self,"is wrong"
            return 0


        for item in ghosts + algebras:
            if self.count(item)>1 and item.f==1:
                print "more than one fermion",item
                return 0


        return 1

     


    def killGhost(self,toKill):
        result=operator(self[:])        
        if toKill.f==1:
            coeff = (-1)**operator(result[:result.index(toKill)]).countFermions()
        else:
            if toKill in ones:
                coeff = -result.count(toKill)
            elif toKill in twos:
                coeff = result.count(toKill)
            else:
                print "error!"

        result.remove(toKill)
        
        return coeff,result


    def addGhost(self,toAdd):
        result = operator(self[:])
        result.append(toAdd)
        result.sortNice()
        if toAdd.f==1:
            sign = (-1)**operator(result[:result.index(toAdd)]).countFermions()
        else:
            sign = 1

        return sign,result







quadratic = [
    [b3,J3,1],
    [bm,Jm,1],
    [bp,Jp,1],
    [bt3,Jt3,1],
    [btm,Jtm,1],
    [btp,Jtp,1],
    [b11m,S11m,-1],
    [b12m,S12m,1],
    [b11p,S11p,-1],
    [b12p,S12p,1],
    [b21m,S21m,-1],
    [b22m,S22m,1],
    [b21p,S21p,-1],
    [b22p,S22p,1]
    ]
commutators = [
    [J3,Jp,Jp,1],
    [J3,Jm,Jm,-1],
    [Jt3,Jtp,Jtp,1],
    [Jt3,Jtm,Jtm,-1],
    [J3,S11p,S11p,0.5],
    [J3,S12p,S12p,0.5],
    [J3,S21p,S21p,0.5],
    [J3,S22p,S22p,0.5],
    [J3,S11m,S11m,-0.5],
    [J3,S12m,S12m,-0.5],
    [J3,S21m,S21m,-0.5],
    [J3,S22m,S22m,-0.5],
    [Jt3,S11p,S11p,0.5],
    [Jt3,S12p,S12p,0.5],
    [Jt3,S21p,S21p,-0.5],
    [Jt3,S22p,S22p,-0.5],
    [Jt3,S11m,S11m,-0.5],
    [Jt3,S12m,S12m,-0.5],
    [Jt3,S21m,S21m,0.5],
    [Jt3,S22m,S22m,0.5],
    [S11p,S22p,Jp,-2],
    [S12p,S21p,Jp,2],
    [S11m,S22m,Jm,2],
    [S12m,S21m,Jm,-2],
    [S11p,S22m,Jtp,2],
    [S12p,S21m,Jtp,-2],
    [S11m,S22p,Jtm,-2],
    [S12m,S21p,Jtm,2],
    [Jp,S11m,S21p,1],
    [Jp,S12m,S22p,1],
    [Jm,S11p,S21m,-1],
    [Jm,S12p,S22m,-1],
    [Jp,S21m,S11p,-1],
    [Jp,S22m,S12p,-1],
    [Jm,S21p,S11m,1],
    [Jm,S22p,S12m,1],
    [Jtp,S11m,S21m,1],
    [Jtp,S12m,S22m,1],
    [Jtm,S11p,S21p,-1],
    [Jtm,S12p,S22p,-1],
    [Jtp,S21p,S11p,-1],
    [Jtp,S22p,S12p,-1],
    [Jtm,S21m,S11m,1],
    [Jtm,S22m,S12m,1],
    [Jp,Jm,J3,2],
    [Jtp,Jtm,Jt3,2],
    [S11p,S12m,J3,2],
    [S11p,S12m,Jt3,-2],
    [S12p,S11m,J3,-2],
    [S12p,S11m,Jt3,2],
    [S21p,S22m,J3,2],
    [S21p,S22m,Jt3,2],
    [S22p,S21m,J3,-2],
    [S22p,S21m,Jt3,-2],
    ]




cubics = [
        [bp,bm,b3,2],
        [b3,bp,bp,1],
        [bm,b3,bm,1],
        [btp,btm,bt3,2],
        [bt3,btp,btp,1],
        [btm,bt3,btm,1],
        [b11m,b12p,b3,-2],
        [b11m,b12p,bt3,2],
        [b12m,b11p,b3,2],
        [b12m,b11p,bt3,-2],
        [b22m,b21p,b3,2],
        [b22m,b21p,bt3,2],
        [b21m,b22p,b3,-2],
        [b21m,b22p,bt3,-2],
        [b22p,b11p,bp,-2],
        [b21p,b12p,bp,2],
        [b22m,b11m,bm,2],
        [b21m,b12m,bm,-2],
        [b22m,b11p,btp,2],
        [b21m,b12p,btp,-2],
        [b22p,b11m,btm,-2],
        [b21p,b12m,btm,2],
        [b12p,b3,b12p,0.5],
        [b12m,b3,b12m,-0.5],
        [b11p,b3,b11p,-0.5],
        [b11m,b3,b11m,0.5],
        [b22m,b3,b22m,-0.5],
        [b22p,b3,b22p,0.5],
        [b21m,b3,b21m,0.5],
        [b21p,b3,b21p,-0.5],
        [b12m,bp,b22p,1],
        [b11m,bp,b21p,-1],
        [b22m,bp,b12p,-1],
        [b21m,bp,b11p,1],
        [b12p,bm,b22m,-1],
        [b11p,bm,b21m,1],
        [b22p,bm,b12m,1],
        [b21p,bm,b11m,-1],
        [b12p,bt3,b12p,0.5],
        [b12m,bt3,b12m,-0.5],
        [b11p,bt3,b11p,-0.5],
        [b11m,bt3,b11m,0.5],
        [b22m,bt3,b22m,0.5],
        [b22p,bt3,b22p,-0.5],
        [b21m,bt3,b21m,-0.5],
        [b21p,bt3,b21p,0.5],
        [b12m,btp,b22m,1],
        [b11m,btp,b21m,-1],
        [b21p,btp,b11p,1],
        [b22p,btp,b12p,-1],
        [b11p,btm,b21p,1],
        [b12p,btm,b22p,-1],
        [b21m,btm,b11m,-1],
        [b22m,btm,b12m,1]
        ]


def commutator(algebraElement1,algebraElement2):

    result = []

    for item in commutators:
        if algebraElement1==item[0] and algebraElement2==item[1]:
            result.append([item[3],item[2]])
        elif algebraElement1==item[1] and algebraElement2==item[0]:
            if algebraElement1.f==1 and algebraElement2.f==1:
                coefficient = 1
            else:
                coefficient = -1
            result.append([coefficient*item[3],item[2]])
    return result
                       


for item in commutators:
    for goat in quadratic:
        if item[0]==goat[1]:
            ghost1=goat[0]
        if item[1]==goat[1]:
            ghost2=goat[0]
    found=0
    for gibbon in cubics:
        if gibbon[0]==ghost1 and gibbon[1]==ghost2:
            target = gibbon
            found=1
            break
        if gibbon[0]==ghost2 and gibbon[1]==ghost1:
            target = gibbon
            found=1
            break

    if not found:
        print "eek not found!"
    else:
        print item[3],target[3]



for item1 in algebras:
    for item2 in algebras:
        print item1,item2,commutator(item1,item2)

result =[]

for item1 in ghosts:
    for item2 in ghosts:
        for item3 in ghosts:
            #don't duplicate results
            if item1.order < item2.order:
                continue
            for pair in quadratic:
                if item1==pair[0]:
                    algebraElement1=pair[1]
                    coefficient1=pair[2]
                if item2==pair[0]:
                    algebraElement2=pair[1]
                    coefficient2=pair[2]
                if item3==pair[0]:
                    algebraElement3=pair[1]
                    coefficient3=pair[2]

            comm = commutator(algebraElement1,algebraElement2)
            
            if item1.f==1 and item2.f==1 and item3.f==1:
                sign = -1
            else:
                sign = 1


            for dummy in comm:
                if dummy[1]==algebraElement3:
                    result.append([item1,item2,item3,-dummy[0]*coefficient1*coefficient2*sign])


for item1 in cubics:
    for item2 in result:
        if set(item1[:3])==set(item2[:3]):
            print item1[:3],item2[:3],item1[3],item2[3], item1[3]-item2[3]
